// src/validator.js
const ast = require('./ast.js');
const { parse } = require("./parser");


/*This function will remove spaces 
from all user input strings to 
enable accurate comparison of two strings 
without the interference of spaces.*/
function removeSpaces(str) {
    return str.replace(/\s+/g, '');
}

// expression doesn't have meaningless brackets
// for expression, standard is an AST from logic rule, userInput is a string
function validator(standardAst, userString) {

    standardString = ast.astToString(standardAst);

    const minLength = Math.min(standardString.length, userString.length);

    for (let i = 0; i < minLength; i++) {
        if (standardString[i] !== userString[i]) {
            return [false, `The student's answer is incorrect at character [${i + 1}]: '${userString[i]}'`];
        }
    }

    if (standardString.length !== userString.length) {
        return [false, `The student's answer is incorrect at character ${minLength + 1}, the answer is not completed`];
    }

    return [true, "The student's answer is correct"];
}

module.exports = { removeSpaces, validator };


