@{%
const ast = require("./ast.js");     // Import the AST module
%}

# Main entry point
sequent -> expression {% id %}
    | _ turnstile _ conclusions {% 
        function(data) {
            return [[], data[3]];
        } 
    %}
    | givens _ turnstile _ conclusions {% 
        function(data) {
            return [data[0], data[4]]; // Return a tuple [givens, conclusion]
        } 
    %}

# Givens

givens -> given ("," _ given):* {% 
    function(data) {
        let result = [data[0]]; 
        for (let i = 0; i < data[1].length; i++) {
            result.push(data[1][i][2]); 
        }
        return result; 
    }
%}

given -> expression {% id %} 

# Conclusion
conclusions -> conclusion ("," _ conclusion):* {% 
    function(data) {
        let result = [data[0]]; 
        for (let i = 0; i < data[1].length; i++) {
            result.push(data[1][i][2]); 
        }
        return result;
    }
%}

conclusion -> expression {% id %} 

# Expressions with precedence
expression -> implication {% id %} 

# right associate
implication -> or _ "->" _ implication {% function(data) { return ast.Imply(data[2], data[0], data[4]); } %} 
            | or {% id %}

# left associate
or -> or _ "||" _ and {% function(data) { return ast.Or(data[2], data[0], data[4]); } %}
   | and {% id %}

# left associate
and -> and _ "&" _ not {% function(data) { return ast.And(data[2], data[0], data[4]); } %}
    | not {% id %}

not -> "!" _ not {% function(data) { return ast.Not(data[0], data[2], null); } %}
    | primary {% id %}

primary -> "(" _ expression _ ")" {% function(data) { return data[2]; } %}
         | TRUE {% id %} 
         | FALSE {% id %} 
         | symbol {% id %}

turnstile -> "|-" {% id %} 

TRUE -> "true"   {% function(data) { return ast.True(1, null, null); } %}

FALSE -> "false"   {% function(data) { return ast.False(0, null, null); } %}

symbol -> [a-zA-Z] {% function(data) { return ast.Symbol(data[0], null, null); } %}

_ -> null     
	| _ [\s]    