//convert logic statement into the AST and check the application of the rule


// Import Nearley and the compiled grammar
const nearley = require("nearley");
const grammar = require("./grammar.js");


// Function to parse input using Nearley
function parse(input) {
    const parser = new nearley.Parser(nearley.Grammar.fromCompiled(grammar)); // Create a parser instance
    parser.feed(input); // Feed the input into the parser
    if (parser.results.length > 1) {
        throw new Error("Ambiguous grammar detected."); // Check for ambiguous results
    }
    return parser.results[0]; // Return the parsed result
}

module.exports = { parse }; // Export the parse function

if (require.main === module) {
    try {
        const astA = parse("!A->(B||C)&D");
        console.log("Parsed result:", JSON.stringify(astA, null, 2));
    } catch (e) {
        console.error("Error:", e.message);
    }
}
